#include <bits/stdc++.h>
#define endl '\n'

//#pragma optimize ("Ofast")
//#pragma target ("sse4")

using namespace std;
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; }
const int MAXN = 13 * 13;
const int mod = (int)1e9 + 7;

/*
struct state
{
    vector<int> d;
    void init(int n) { d.assign(12, 0); d[0] = n; }
    uint64_t get_hash()
    {
        uint64_t v = 0;
        for(int x: d) v = v * 13llu + x;
        return v;
    }
};*/

uint64_t pw16[MAXN];
uint64_t ap[MAXN];

struct state
{
    uint64_t hsh;
    void init(int n) { hsh = n; }
    inline uint64_t get_hash() { return hsh; }

    int get(int p) { return (hsh >> ap[p]) & 15llu; }
    void add(int p) { hsh += pw16[p]; }
    void rem(int p) { hsh -= pw16[p]; }
};

char m[12];

int n;
string s;

void read()
{
    cin >> n;
    cin >> s;
    //for(int i = 0; i < 12 * n; i++) s+='?';
    //s[rand() % s.size()] = 'J';
}

unordered_map<uint64_t, int> memo;

vector<int> li[256];

int rec(state it, int da)
{
    if(da == n * 12) return 1;

    uint64_t h = it.get_hash();
    if(memo.count(h)) return memo[h];

    int64_t answer = 0;

    if(s[da] == '?')
        for(int i = 0; i < 12; i++)
        {
            int c = it.get(i);
            if(c)
            {
                state nxt = it;
                nxt.rem(i);
                if(i != 11) nxt.add(i + 1);
                answer += c * 1ll * rec(nxt, da + 1);
            }
        }
    else
        for(int i: li[s[da]])
        {
            int c = it.get(i);
            if(c)
            {
                state nxt = it;
                nxt.rem(i);
                if(i != 11) nxt.add(i + 1);
                answer += c * 1ll * rec(nxt, da + 1);
            }
        }

    return memo[h] = (answer % mod);

}

void solve()
{
    pw16[0] = 1;
    for(int i = 1; i < MAXN; i++)
        pw16[i] = pw16[i - 1] * 16llu;

    for(int i = 0; i < MAXN; i++)
        ap[i] = i << 2;

    memo.reserve(1024);

    state tmp;
    tmp.init(n);

    m[0] = 'J';
    m[1] = 'F';
    m[2] = 'M';
    m[3] = 'A';
    m[4] = 'M';
    m[5] = 'J';
    m[6] = 'J';
    m[7] = 'A';
    m[8] = 'S';
    m[9] = 'O';
    m[10] = 'N';
    m[11] = 'D';

    for(int i = 'A'; i <= 'Z'; i++)
        for(int x = 0; x < 12; x++)
            if(m[x] == (char)i) li[i].push_back(x);

    queue<pair<state, int> > Q;
    Q.push({tmp, 0});
    memo[Q.front().first.get_hash()] = 1;

    int64_t answer = 0;

    while(!Q.empty())
    {
        state it = Q.front().first;
        int da = Q.front().second;
        int curr_dp = memo[it.get_hash()];
        Q.pop();

        if(s[da] == '?')
        {
            uint64_t dummy = it.get_hash();
            for(int i = 0; i < 12; i++)
            {
                int c = dummy & 15;
                dummy >>= 4;
                if(c)
                {
                    state nxt = it;
                    nxt.rem(i);
                    if(i != 11) nxt.add(i + 1);

                    if(da + 1 == 12 * n)
                    {
                        answer += c * 1ll * curr_dp;
                        answer %= mod;
                    }
                    else
                    {
                        uint64_t h = nxt.get_hash();
                        if(!memo.count(h)) Q.push({nxt, da + 1});
                        memo[h] = (memo[h] + c * 1ll * curr_dp) % mod;
                    }
                }

            }
        }
        else
            for(int i: li[s[da]])
            {
                int c = it.get(i);
                if(c)
                {
                    state nxt = it;
                    nxt.rem(i);
                    if(i != 11) nxt.add(i + 1);

                    if(da + 1 == 12 * n)
                    {
                        answer += c * 1ll * curr_dp;
                        answer %= mod;
                    }
                    else
                    {
                        uint64_t h = nxt.get_hash();
                        if(!memo.count(h)) Q.push({nxt, da + 1});
                        memo[h] = (memo[h] + c * 1ll * curr_dp) % mod;
                    }
                }
            }
    }

    cout << answer << endl;

    //cout << rec(tmp, 0) << endl;
    //cout << "cnt states: " << memo.size() << endl;
}
int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	read();
	solve();
	return 0;
}
