#include <bits/stdc++.h>
#define endl '\n'

//#pragma optimize ("O3")
//#pragma target ("sse4")

using namespace std;
template<class T, class T1> void chkmax(T &x, const T1 &y) { if(x < y) x = y; }
template<class T, class T1> void chkmin(T &x, const T1 &y) { if(x > y) x = y; }
const int MAXN = (int)1e5 + 17;

int n, q;
struct node
{
	int64_t lazy1, lazy, sum;
	node *l, *r;
	node() { l = r = nullptr; lazy = lazy1 = sum = 0; }
};

using pnode = node*;

pnode node_copy(pnode x)
{
    return x;
	pnode ret = new node();
	ret->lazy1 = x->lazy1;
	ret->r = x->r;
	ret->l = x->l;
	ret->lazy = x->lazy;
	ret->sum = x->sum;
	return ret;
}

void extend_l(int l, int r, pnode &t) { if(!t->l) t->l = new node(); }
void extend_r(int l, int r, pnode &t) { if(!t->r) t->r = new node(); }

void push(int l, int r, pnode &t)
{
	if((t->lazy || t->lazy1))
	{
		t->sum += (r - l + 1) * 1ll * t->lazy;
		t->sum += t->lazy1 * 1ll * (r - l) * 1ll * (r - l + 1) / 2ll;

		if(l != r)
		{
			/*if(!t->l) t->l = new node();
			else t->l = node_copy(t->l);

			if(!t->r) t->r = new node();
			else t->r = node_copy(t->r);
            */

            extend_l(l, r, t);
            extend_r(l, r, t);

			t->l->lazy += t->lazy;
			t->r->lazy += t->lazy;

			t->l->lazy1 += t->lazy1;
			t->r->lazy1 += t->lazy1;

			int mid = (l + r) >> 1;
			t->r->lazy += t->lazy1 * 1ll * (mid - l + 1);
		}

		t->lazy = t->lazy1 = 0;
	}
}

inline int64_t SUM(pnode x) { return x ? x->sum : 0; }

void pushup(int l, int r, pnode &t)
{
	t->sum = SUM(t->l) + SUM(t->r);
	t->lazy1 = t->lazy = 0;
}

pnode add(int ql, int qr, int st, int d, int l, int r, pnode &t)
{
	//cout << ql << " " << qr << " " << l << " " << r << " is t ok: " << (t != nullptr) << endl << flush;

	push(l, r, t);
	pnode nw = node_copy(t);

	if(ql > r || qr < l) return nw;

	if(ql <= l && r <= qr)
	{
		nw->lazy += (l - ql) * 1ll * d + st;
		nw->lazy1 += d;
		push(l, r, nw);
		return nw;
	}

	int mid = (l + r) >> 1;
	//if(ql <= mid)
	 extend_l(l, r, t), nw->l = add(ql, qr, st, d, l, mid, t->l);
	//if(mid < qr)
	extend_r(l, r, t), nw->r = add(ql, qr, st, d, mid + 1, r, t->r);

	pushup(l, r, nw);
	return nw;
}

int64_t query(int ql, int qr, int l, int r, pnode &t)
{
	push(l, r, t);
	if(ql <= l && r <= qr)
		return t->sum;

	int mid = (l + r) >> 1;
	int64_t answer = 0;

	if(ql <= mid)
	{
		if(!t->l) answer += 0;
		else answer += query(ql, qr, l, mid, t->l);
	}

	if(mid < qr)
	{
		if(!t->r) answer += 0;
		else answer += query(ql, qr, mid + 1, r, t->r);
	}

	return answer;
}

void read()
{
	cin >> n >> q;
}

pnode root[MAXN];

string tos(__int128 x)
{
    string ret;
    while(x)
    {
        ret += ((x % 10) + (char)'0');
        x /= 10;
    }

    reverse(ret.begin(), ret.end());
    return ret;
}

void solve()
{
	for(int i = 0; i < MAXN; i++) root[i] = nullptr;

	for(int i = 1; i <= q; i++)
	{
		int type;
		cin >> type;

		if(type == 1)
		{
			int row, l, r;
			int64_t st, d;
			cin >> row >> l >> r >> st >> d;
			if(!root[row]) root[row] = new node();
			root[row] = add(l, r, st, d, 1, n, root[row]);
			//cout << "S: " << SUM(root[row]) << endl;
		}
		else if(type == 2)
		{
			int row, l, r;
			cin >> row >> l >> r;
			if(!root[row]) cout << 0 << endl;
			else cout << query(l, r, 1, n, root[row]) << endl;
		}
		else if(type == 3)
		{
			int row1, row2;
			cin >> row1 >> row2;
			if(!root[row1]) root[row2] = nullptr;
			else root[row2] = node_copy(root[row1]);
		}
	}
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);

	read();
	solve();
	return 0;
}
