#include "bookshelf.h"
#include<iostream>
using namespace std;

//long long bookswap(int i, int j)
//void answer(int p)

const int MAX_N=100100;

int atp[MAX_N];
int val[MAX_N];
int it[MAX_N];
int civ;
int base=1;
int n;

void updateIT(int p)
{
    while (p<MAX_N)
    {
        ++it[p];
        p+=p&(-p);
    }
}
int getIT(int p)
{
    int sum=0;
    while (p>0)
    {
        sum+=it[p];
        p-=p&(-p);
    }
    return sum;
}
int findAboveBase(int diff)
{
    int l=base+1;
    int r=n;
    int m;
    int last;
    int pd;

    while (l<=r)
    {
        m=(l+r)/2;
        pd=m-base;
        pd-=getIT(m);
        pd+=getIT(base);
        //cerr<<diff<<":  l: "<<l<<" r: "<<r<<"  m: "<<m<<" pd: "<<pd<<endl;
        if (pd>diff) r=m-1;
        else if (pd<diff) l=m+1;
        else
        {
            last=m;
            r=m-1;
        }
    }

    return last;
}
int findBelowBase(int diff)
{
    int l=1;
    int r=base-1;
    int m;
    int last;
    int pd;

    while (l<=r)
    {
        m=(l+r)/2;
        pd=base-m;
        pd-=getIT(base-1);
        pd+=getIT(m-1);
        if (pd>diff) l=m+1;
        else if (pd<diff) r=m-1;
        else
        {
            last=m;
            l=m+1;
        }
    }

    return last;
}

void bookshelf(int N, long long Inv)
{
    n=N;
    civ=Inv;
    int niv;
    for (int i=1;i<=n;++i)
    {
        atp[i]=i;
    }
    for (int i=2;i<=n;++i)
    {
        niv=bookswap(i-1,i);
        if (niv<civ) ++base;
        civ=niv;
        swap(atp[i-1],atp[i]);
    }
    /*cerr<<"base: "<<base<<endl;
    for (int i=1;i<=n;++i)
    {
        cerr<<atp[i]<<' ';
    }
    cerr<<endl;*/
    val[atp[n]]=base;
    updateIT(base);
    int diff;
    int i=1,j=n-1;
    bool f=0;
    int v;
    int cpb=n;
    int cp;
    while (i<=j)
    {
        if (f==0)
        {
            niv=bookswap(i,cpb);
            swap(atp[i],atp[cpb]);
            //cerr<<"\nswap: "<<i<<" "<<cpb<<endl;
            cp=cpb;
            cpb=i;
            ++i;
            f=1;

            //cerr<<"civ: "<<civ<<" niv: "<<niv<<endl;
            diff=civ-niv;
            civ=niv;
        }
        else
        {
            niv=bookswap(j,cpb);
            swap(atp[j],atp[cpb]);
            //cerr<<"\nswap: "<<j<<" "<<cpb<<endl;
            cp=cpb;
            cpb=j;
            --j;
            f=0;

            //cerr<<"civ: "<<civ<<" niv: "<<niv<<endl;
            diff=niv-civ;
            civ=niv;
        }

        if (diff<0)
        {
            diff+=1;
            diff/=2;
            diff-=1;
        }
        else
        {
            diff-=1;
            diff/=2;
            diff+=1;
        }

        if (diff<0) v=findBelowBase(-diff);
        else v=findAboveBase(diff);

        //cerr<<"diff: "<<diff<<endl;
        //cerr<<"value: "<<v<<endl;

        updateIT(v);
        val[atp[cp]]=v;
    }
    answer(val);
}
