#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;

const int MAX_N=1e5;
int n,q;
long long it0[MAX_N];
long long it1[MAX_N];
long long it2[MAX_N];

void updateIt0(int p, long long v)
{
    while (p<MAX_N)
    {
        it0[p]+=v;
        p+=p&(-p);
    }
}
void updateIt1(int p, long long v)
{
    while (p<MAX_N)
    {
        it1[p]+=v;
        p+=p&(-p);
    }
}
void updateIt2(int p, long long v)
{
    while (p<MAX_N)
    {
        it2[p]+=v;
        p+=p&(-p);
    }
}
long long getIt0(int p)
{
    long long sum=0;
    while (p>0)
    {
        sum+=it0[p];
        p-=p&(-p);
    }
    return sum;
}
long long getIt1(int p)
{
    long long sum=0;
    while (p>0)
    {
        sum+=it1[p];
        p-=p&(-p);
    }
    return sum;
}
long long getIt2(int p)
{
    long long sum=0;
    while (p>0)
    {
        sum+=it2[p];
        p-=p&(-p);
    }
    return sum;
}

void makeUpdate(int f, long long st, long long d)
{
    updateIt0(f,2*st-2*f*st-f*d+f*f*d);
    updateIt1(f,d-2*f*d+2*st);
    updateIt2(f,d);
}
long long getPrefix(int f)
{
    /*cerr<<f<<": "<<getIt0(f)<<endl;
    cerr<<f<<": "<<getIt1(f)<<endl;
    cerr<<f<<": "<<getIt2(f)<<endl;
    cerr<<f<<": "<<getIt0(f)+getIt1(f)*f+getIt2(f)*f*f<<endl<<endl;*/
    return getIt0(f)+getIt1(f)*f+getIt2(f)*f*f;
}
void input()
{
    cin>>n>>q;
}
void solve()
{
    long long type,r,f,t,st,d;
    long long sum;
    long long last;
    for (int i=0;i<q;++i)
    {
        cin>>type;
        if (type==1)
        {
            cin>>r>>f>>t>>st>>d;
            makeUpdate(f,st,d);
            last=(t-f+1)*d+st;
            makeUpdate(t+1,-last,-d);
        }
        else
        {
            cin>>r>>f>>t;
            sum=getPrefix(t)-getPrefix(f-1);
            cout<<sum/2<<'\n';
        }
    }
}
int main()
{
    cin.tie(0);
    ios::sync_with_stdio(0);

    input();
    solve();

    return 0;
}
