#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 100007;
const int ROWS = 100000;

struct tree_node {
  int from,to;
  long long sum,lazy_first,lazy_diff;
  tree_node *left, *right;

  tree_node(): left(NULL), right(NULL) {}
  tree_node(int a, int b): from(a), to(b), sum(0), lazy_first(0), lazy_diff(0), left(NULL), right(NULL) {}
};

typedef tree_node *node_ptr;

int n,q,which[N];
node_ptr root[N];
int update_from,update_to,update_first,update_diff;

void extend(node_ptr &a) {
  if(a->left==NULL && a->from<a->to) {
    a->left=new tree_node(a->from,(a->from+a->to)/2);
    a->right=new tree_node((a->from+a->to)/2+1,a->to);
  }
}

int get_length(node_ptr &a) {
  return a==NULL ? 0 : a->to-a->from+1;
}

long long get_sum(long long first, long long diff, long long len) {
  return first*len+diff*len*(len-1)/2;
}

long long get_sum(node_ptr &a) {
  return a==NULL ? 0 : a->sum;
}

void apply_lazy(node_ptr &a) {
  if(a!=NULL) if(a->lazy_first!=0 || a->lazy_diff!=0) {
    a->sum+=get_sum(a->lazy_first,a->lazy_diff,get_length(a));
    if(a->from<a->to) {
      extend(a);
      
      a->left->lazy_first+=a->lazy_first;
      a->left->lazy_diff+=a->lazy_diff;

      a->right->lazy_first+=a->lazy_first+a->lazy_diff*get_length(a->left);
      a->right->lazy_diff+=a->lazy_diff;
    }

    a->lazy_first=0;
    a->lazy_diff=0;
  }
}

void update(node_ptr &root) {
  apply_lazy(root);

  if(root==NULL) return;
  if(update_from>update_to || root->from>root->to || root->from>update_to || root->to<update_from) return;

  if(root->from>=update_from && root->to<=update_to) {
    root->sum+=get_sum(update_first+update_diff*1ll*(root->from-update_from),update_diff,get_length(root));
   
    if(root->from<root->to) {
      extend(root);

      root->left->lazy_first+=update_first+update_diff*1ll*(root->left->from-update_from);
      root->left->lazy_diff+=update_diff;
      root->right->lazy_first+=update_first+update_diff*1ll*(root->right->from-update_from);
      root->right->lazy_diff+=update_diff;
    }

    return;
  }

  extend(root);

  update(root->left);
  update(root->right);

  root->sum=get_sum(root->left)+get_sum(root->right);
}

long long query(node_ptr &root, int l, int r) {
  if(root==NULL) return 0;
  if(root->from>r || root->to<l) return 0;

  apply_lazy(root);

  if(root->from>=l && root->to<=r) return root->sum;

  extend(root);

  return query(root->left,l,r)+query(root->right,l,r);
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int type,i,x,y,z,st,d;

  scanf("%d %d", &n, &q);

  for(i=1;i<=ROWS;i++) {
    which[i]=i;
    root[i]=NULL;
  }

  while(q--) {
    scanf("%d", &type);
    
    if(type==1) {
      scanf("%d %d %d %d %d", &x, &update_from, &update_to, &update_first, &update_diff);
      
      if(root[which[x]]==NULL) root[which[x]]=new tree_node(1,n);

      update(root[which[x]]);
    }
    else if(type==2) {
      scanf("%d %d %d", &x, &y, &z);
      
      if(root[which[x]]==NULL) printf("0\n");      
      else printf("%lld\n", query(root[which[x]],y,z));
    }
    else {
      scanf("%d %d", &x, &y);
      if(root[x]==NULL) {
        root[y]=NULL;
        continue;
      }
      if(root[y]==NULL) root[y]=new tree_node();
      *root[y]=*root[x];
      //which[y]=which[x];
    }
  }

  return 0;
}
