//Does it come from the east to west ...
#include <iostream>
#include <cstdint>
#include <cstdint>
#include <string>
#include <vector>
#include <array>
#include <algorithm>
#include <unordered_map>

const uint32_t M_CNT = 13;
const uint32_t MAX_N = 13;
const uint32_t MAX_COMB = 5.3e6;

const uint64_t H_BASE = 73;
const uint64_t H_MOD = 1428571428573197ULL;
const uint32_t MOD = 1e9 + 7;

typedef std::array<uint32_t, M_CNT> comb;

std::string notes;
uint32_t yCnt;

uint64_t calc_hash(const comb &c) {
	uint64_t ans = 0;
	for (const uint32_t &i : c) {
		ans = ans * H_BASE + i;
		ans %= H_MOD;
	}
	return ans;
}

bool advance_comb(comb &c) {
	uint32_t curS = 0;
	for (uint32_t i = M_CNT - 1;i < M_CNT;i--) {
		if (curS > 0) {
			c[i]++;
			for (uint32_t j = i + 1;j < M_CNT;j++) {
				c[j] = 0;
			}
			c[M_CNT - 1] = curS - 1;
			return true;
		}
		curS += c[i];
	}
	return false;
}

std::ostream& operator<< (std::ostream &s, const comb &c) {
	s << "(";
	for (const uint32_t &i : c) {
		s << i << " ";
	}
	return s << ")";
}

uint32_t combHashes[MAX_COMB];
std::unordered_map<uint64_t, uint32_t>  dp;

uint32_t curComb;

void input() {
	std::ios::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> yCnt;
	std::cin >> notes;
	notes = notes + '?';
	for (char &c : notes) {
		c -= '?';
	}
}

const uint32_t MAX_CH = 50;

bool allowed[MAX_CH][M_CNT];

void allow(char c, uint32_t m) {
	allowed[c - '?'][M_CNT - m - 1] = true;
}

void build_allowed() {
	allow('J', 0);
	allow('F', 1);
	allow('M', 2);
	allow('A', 3);
	allow('M', 4);
	allow('J', 5);
	allow('J', 6);
	allow('A', 7);
	allow('S', 8);
	allow('O', 9);
	allow('N', 10);
	allow('D', 11);

	for (uint32_t i = 0;i < M_CNT;i++) {
		allow('?', i);
	}

}

uint32_t combCnt = 0;

comb init_comb() {
	comb c;
	std::fill(c.begin(), c.end(), 0);
	c[M_CNT - 1] = yCnt;
	return c;
}

void prepare_hashes() {
	comb c = init_comb();
	do {
		combHashes[combCnt++] = calc_hash(c);
		//std::
	} while (advance_comb(c));
	std::sort(combHashes, combHashes + combCnt);
}

uint32_t hash_ind(uint32_t v) {
	return v;
	uint32_t l = 0, h = combCnt;
	while (h - l > 1) {
		uint32_t m = (h + l) >> 1;
		if (combHashes[m] <= v) {
			l = m;
		} else {
			h = m;
		}
	}
	return l;
}

uint32_t calc_dp() {
	comb c = init_comb();
	dp[calc_hash(c)] = 1;

	comb nC;
	do {
		uint64_t cHash = calc_hash(c);
		uint64_t cHashInd = cHash;
		uint32_t curInd = 0;


		for (uint32_t i = 0;i < M_CNT;i++) {
			curInd += i * c[M_CNT - i - 1];
		}

		//std::cerr << c << " " << dp[cHashInd] << " " << curInd << "\n";

		for (uint32_t i = M_CNT - 1;i > 0;i--) {
			if ((!allowed[notes[curInd]][i]) || (c[i] == 0)) {
				continue;
			} 
			nC = c;
			nC[i]--;
			nC[i - 1]++;

			//std::
			uint64_t nHash = calc_hash(nC);
			uint64_t nHashInd = nHash;
			uint64_t curAdd = dp[cHashInd];
			curAdd = curAdd * c[i] % MOD;
			dp[nHashInd] += curAdd;
			dp[nHashInd] %= MOD;
		}

		//std::
	} while (advance_comb(c));

	return dp[calc_hash(c)];
}

int main() {
	input();
	build_allowed();
	//prepare_hashes();
	//std::
	std::cout << calc_dp() << "\n";
}
