# include "bookshelf.h"
# include <vector>
# include <algorithm>

using namespace std;

const int MAX_N = 1e5 + 10;

int ans[MAX_N];

int pos[MAX_N];
int ipos[MAX_N];

long long invn;

int cnt;

int tree[MAX_N];

int nn;

void update (int idx, int u)
{
	for (; idx <= nn; idx += (idx & (-idx)))
		tree[idx] += u;
}

int find (int idx)
{
	int aa = 0;
	for (; idx; idx -= (idx & (-idx)))
		aa += tree[idx];
	return aa;
}

inline int smaller (int x)
{
	return (x - 1) - find (x - 1);
}

inline int bigger (int x)
{
	return (nn - x) - (find (nn) - find (x));
}

bool comp (int x, int y)
{
	if (x == y)
		return false;
	long long old = invn;
	bool fl = false;
	if (pos[x] > pos[y])
		fl = true;
	
	invn = bookswap (pos[x], pos[y]);
	ipos[pos[x]] = y;
	ipos[pos[y]] = x;
	swap (pos[x], pos[y]);
		
	cnt ++;
	
	return (old > invn) ^ fl;
}

void bookshelf (int n, long long inv)
{
	nn = n;
	
	invn = inv;
	
	int i, ma = 1;
	
	for (i = 1; i <= n; i ++)
		pos[i] = ipos[i] = i;
	
	for (i = 2; i <= n; i ++)
		if (!comp (ma, i))
			ma = i;
			
	comp (ipos[1], ma);
	
	ans[ma] = n;
	update (n, 1);
	
	///printf ("max %d %d %d\n", ma, pos[ma], ipos[pos[ma]]);
	
	int f = 0, x, y, le = 1, ri = n, l, r, mid;
	
	for (i = 1; i <= n; i ++)
	{
		if (i == ma)
			continue;
		if (!f)
		{
			
			///printf ("++> %d %d %d\n", i, pos[i], ipos[pos[i]]);
		
			long long old = invn;
			
			x = ma;
			y = ipos[ri];
			
			///printf ("++> %d %d %d\n", y, pos[y], ipos[pos[y]]);
			
			invn = bookswap (pos[x], pos[y]);
			
			ipos[pos[x]] = y;
			ipos[pos[y]] = x;
			swap (pos[x], pos[y]);
			
			l = 0;
			r = n + 1;
			while (r - l > 1)
			{
				mid = (l + r) >> 1;
				long long crr = old - (ri - le) - bigger (mid) + smaller (mid);
				
				///printf ("%d %d %d %d %d %lld %lld %lld\n", mid, le, ri, bigger (mid), smaller (mid), crr, old, invn);
				
				
				if (crr <= invn)
					l = mid;
				else
					r = mid; 
			}
			
			ans[y] = l;
			update (l, 1); 
			
			le ++;
			///printf ("ans> %d %d %d = %d\n", y, pos[y], ipos[pos[y]], ans[y]); 
		}
		else
		{
				
				
			long long old = invn;
			
			x = ma;
			y = ipos[le];
			
			
			///printf ("++> %d %d %d\n", y, pos[y], ipos[pos[y]]);
			
			invn = bookswap (pos[x], pos[y]);
			
			ipos[pos[x]] = y;
			ipos[pos[y]] = x;
			swap (pos[x], pos[y]);
			
			l = 0;
			r = n + 1;
			while (r - l > 1)
			{
				mid = (l + r) >> 1;
				long long crr = old + (ri - le) + bigger (mid) - smaller (mid);
				///printf ("%d %d %d %d %d %lld %lld %lld\n", mid, le, ri, bigger (mid), smaller (mid), crr, old, invn);
				if (crr <= invn)
					r = mid;
				else
					l = mid; 
			}
			
			ans[y] = r;
			update (r, 1);
			
			ri --;
			///printf ("ans> %d %d %d = %d\n", y, pos[y], ipos[pos[y]], ans[y]); 
		}
		
		f ^= 1;
	}
			
	answer (ans);
}

