# include <cstdio>
# include <algorithm>

using namespace std;

const int M = 100000;

int n, q;

long long tree[M * 4];
long long lazy_st[M * 4];
long long lazy_add[M * 4];

void lazy_up (int idx, long long l, long long r)
{
	///printf ("lazy %d %lld %lld %lld %lld %lld\n", idx, l, r, tree[idx], lazy_st[idx], lazy_add[idx]);

	tree[idx] += (r - l + 1) * lazy_st[idx];
	tree[idx] += (r - l) * (r - l + 1) / 2 * lazy_add[idx];
	
	if (l != r)
	{
		lazy_st[idx * 2] += lazy_st[idx];
	
		int mid = (l + r) >> 1;
		lazy_st[idx * 2 + 1] += (lazy_st[idx] + (mid - l + 1) * lazy_add[idx]);
	
		lazy_add[idx * 2] += lazy_add[idx];
		lazy_add[idx * 2 + 1] += lazy_add[idx];
	}
	
	lazy_st[idx] = lazy_add[idx] = 0;
}

void update (int idx, int l, int r, int p, int q, long long us, long long ud)
{
	
	lazy_up (idx, l, r);
	///printf ("%d %d %d %lld - %d %d - %lld %lld\n", idx, l, r, tree[idx], p, q, us, ud);
	if (q < l || r < p)
		return;
	if (p <= l && r <= q)
	{
		lazy_st[idx] += us;
		lazy_add[idx] += ud;
		lazy_up (idx, l, r);
		
		///printf ("%d %d %d %lld\n", idx, l, r, tree[idx]);
		return;
	}
	
	int mid = (l + r) >> 1;
	
	update (idx * 2, l, mid, p, q, us, ud);
	
	update (idx * 2 + 1, mid + 1, r, p, q, us + max (0, min (mid - l + 1, mid - p + 1)) * ud, ud);
	
	tree[idx] = tree[idx * 2] + tree[idx * 2 + 1];
	
	///printf ("%d %d %d %lld\n", idx, l, r, tree[idx]);
}

long long find (int idx, int l, int r, int p, int q)
{
	lazy_up (idx, l, r);
	///printf ("%d %d %d %lld\n", idx, l, r, tree[idx]);
	if (q < l || r < p)
		return 0;
	if (p <= l && r <= q)
		return tree[idx];
	
	int mid = (l + r) >> 1;
	
	long long ans = 0;
	
	ans += find (idx * 2, l, mid, p, q);
	ans += find (idx * 2 + 1, mid + 1, r, p, q);
	
	tree[idx] = tree[idx * 2] + tree[idx * 2 + 1];
	
	///printf ("%d %d %d %lld\n", idx, l, r, tree[idx]);
	return ans;
}


int main ()
{
	int i, t, r, from, to, st, d;
	
	scanf ("%d%d", &n, &q);
	
	while (q --)
	{
		scanf ("%d %d %d %d", &t, &r, &from, &to);
		if (t == 1)
		{
			scanf ("%d %d", &st, &d);
			update (1, 1, M, from, to, st, d);
		}
		else
			printf ("%lld\n", find (1, 1, M, from, to));
	}
	return 0;
}

