#include<iostream>
#include<stdio.h>
#include<algorithm>
#include<vector>
#include "bookshelf.h"
using namespace std ;

#define MAXN 100007

long long stpos[ 3 * MAXN ] ;

long long val[ MAXN ] ;
long long id[ MAXN ] ;

int ans[ MAXN ] ;

class Tree {
	public :
	int tr[ 5 * MAXN ] ;
	void init ( int where , int IL , int IR ) {
		if ( IL == IR ) {
			tr[ where ] = 1 ;
			return ;
		}
		int mid = ( IL + IR ) / 2 ;
		init ( 2 * where , IL , mid ) ;
		init ( 2 * where + 1 , mid + 1 , IR ) ;
		tr[ where ] = ( tr[ 2 * where ] + tr[ 2 * where + 1 ] ) ;
	}
	void update ( int where , int IL , int IR , int pos ) {
		if ( IR < pos || pos < IL ) { return ; }
		if ( IL == IR ) {
			tr[ where ] = 0 ;
			return ;
		}
		int mid = ( IL + IR ) / 2 ;
		if ( pos <= mid ) {
			update ( 2 * where , IL , mid , pos ) ;
		}
		else {
			update ( 2 * where + 1 , mid + 1 , IR , pos ) ;
		}
		tr[ where ] = ( tr[ 2 * where ] + tr[ 2 * where + 1 ] ) ;
	}
	int query ( int where , int IL , int IR , int pos ) {
		if ( IL == IR ) { return IL ; }
		int mid = ( IL + IR ) / 2 ;
		if ( tr[ 2 * where ] < pos ) {
			return query ( 2 * where + 1 , mid + 1 , IR , pos - tr[ 2 * where ] ) ;
		}
		else {
			return query ( 2 * where , IL , mid , pos ) ;
		}
	}
};

Tree w ;

void bookshelf ( int n, long long inv ) {
	int i , j ;
	for ( i = 1 ; i <= 3 * n ; i ++ ) {
		stpos[ i ] = 1LL * ( n + 1 ) * ( n + 1 ) ; 
	}
	val[ 1 ] = stpos[ n ] ;
	id[ 1 ] = n ;
	stpos[ n ] -- ;
	long long X = 0 ;
	long long lst = inv ;
	for ( i = 2 ; i <= n ; i ++ ) {
		bool fl = false ;
		int coef ;
		long long ret , prv ;
		ret = bookswap ( i - 1 , i ) ;
		if ( ret == lst - 1 ) { fl = true ; }
		if ( fl == true ) { X ++ ; coef = -1 ; }
		else { coef = 1 ; }
		if ( i == 2 ) {
			prv = bookswap ( i - 1 , i ) ;
		}
		else {
			bookswap ( i - 1 , i ) ;
			prv = bookswap ( 1 , i - 1 ) ;
		}
		
		ret = bookswap ( 1 , i ) ;
		lst = ret ;
		//bookswap ( 1 , i ) ;
		long long sm1 = X ;
		long long bg1 = ( i - 1 ) - sm1 ;
		//printf ( "%d --> %d %d %d %d\n" , i , prv , sm1 , bg1 , ret ) ;
		prv = prv - sm1 + bg1 ;
		prv = ret - prv ;
		long long sm2 = ( prv + i - 1 + coef ) / 2 ;
		//printf ( "--- %d\n" , prv + i - 1 ) ;
		long long bg2 = ( i - 1 ) - sm2 ;
		//printf ( "--- %d %d\n" , sm2 , bg2 ) ;
		ans[ i ] = sm2 ;

	}
	w.init ( 1 , 1 , n ) ;
	for ( i = n ; i >= 1 ; i -- ) {
		int ret = w.query ( 1 , 1 , n , ans[ i ] + 1 ) ;
		ans[ i ] = ret ;
		w.update ( 1 , 1 , n , ret ) ;
	}
	answer ( ans ) ;
}
