#include<iostream>
#include<stdio.h>
using namespace std ;

#define MAXN 100007

int n , q ;

long long totalseen ;

struct tree {
	int IL , IR ;
 	tree *pl , *pr ;
	long long add ;
	long long lazyadd ;
	int lazyprog ;
	tree ( ) {
		this->IL = this->IR = 0 ;
		this->add = 0 ;
		this->lazyadd = 0 ;
		this->lazyprog = 0 ;
		this->pl = this->pr = NULL ;
	}
	tree ( int _IL , int _IR ) {
		this->IL = _IL ;
		this->IR = _IR ;
		this->add = 0 ;
		this->lazyadd = 0 ;
		this->lazyprog = 0 ;
		this->pl = this->pr = NULL ;
	}
	void push_lazy ( ) {
		int mid = ( this->IL + this->IR ) / 2 ;
		if ( this->IL != this->IR && this->pl == NULL ) {
			this->pl = new tree ( this->IL , mid ) ;
			this->pr = new tree ( mid + 1 , this->IR ) ;
		}
		this->add += 1LL * ( this->IR - this->IL + 1 ) * this->lazyadd ;
		if ( this->IL != this->IR ) {
			this->pl->lazyadd += this->lazyadd ;
			this->pr->lazyadd += this->lazyadd ;
			this->pr->lazyadd += 1LL * this->lazyprog * ( this->pl->IR - this->pl->IL + 1 ) ;
		}
		this->lazyadd = 0 ;
		long long len = ( this->IR - this->IL + 1 ) ;
		this->add += 1LL * this->lazyprog * ( len * ( len - 1 ) / 2 ) ;
		if ( this->IL != this->IR ) { 
			this->pl->lazyprog += this->lazyprog ;
			this->pr->lazyprog += this->lazyprog ;
		}
		this->lazyprog = 0 ;
	}
	void update ( int CURL , int CURR , long long nwadd , long long nwperiod ) {
		this->push_lazy ( ) ;
		if ( CURR < this->IL || this->IR < CURL ) {
			return ;
		}
		if ( CURL <= this->IL && this->IR <= CURR ) {
			this->lazyadd += nwadd + 1LL * nwperiod * totalseen ;
			this->lazyprog += nwperiod ;
			this->push_lazy ( ) ;
			totalseen += ( this->IR - this->IL + 1 ) ;
			return ;
		}
		this->pl->update ( CURL , CURR , nwadd , nwperiod ) ;
		this->pr->update ( CURL , CURR , nwadd , nwperiod ) ;
		this->add = ( this->pl->add + this->pr->add ) ;
	}
	long long query ( int CURL , int CURR ) {
		this->push_lazy ( ) ;
		if ( CURR < this->IL || this->IR < CURL ) {
			return 0 ;
		}
		if ( CURL <= this->IL && this->IR <= CURR ) {
			return this->add ;
		}
		return ( this->pl->query ( CURL , CURR ) + this->pr->query ( CURL , CURR ) ) ;
	}
};

tree *root[ MAXN ] ;

void input ( ) {
	scanf ( "%d%d" , &n , &q ) ;
	int i ;
	for ( i = 1 ; i < MAXN ; i ++ ) {
		root[ i ] = new tree ( 1 , n ) ;
	}
}

void solve ( ) {
	int i ;
	int type ;
	while ( q != 0 ) {
		q -- ;
		scanf ( "%d" , &type ) ;
		if ( type == 1 ) {
			totalseen = 0 ;
			int id , st , en , nwadd , nwperiod ;
			scanf ( "%d%d%d%d%d" , &id , &st , &en , &nwadd , &nwperiod ) ;
			root[ id ]->update ( st , en , nwadd , nwperiod ) ;
		}
		else if ( type == 2 ) {
			int id , st , en ;
			scanf ( "%d%d%d" , &id , &st , &en ) ;
			printf ( "%lld\n" , root[ id ]->query ( st , en ) ) ;
		}
	}
}

int main ( ) {
	input ( ) ;
	solve ( ) ;
	return 0 ;
}
