#include<iostream>
#include<cstdio>
#include<algorithm>
#include<cmath>
using namespace std;
struct iliqn
{
    long long st;
    pair<long long,long long> lazy;
    iliqn * l;
    iliqn * r;
    iliqn()
    {
        st=0;
        lazy.first=lazy.second=0;
        l=r=NULL;
    }
    iliqn(long long _st, long long l1, long long l2)
    {
        st=_st;
        lazy.first=l1;
        lazy.second=l2;
        l=r=NULL;
    }
    iliqn(long long _st, long long l1, long long l2, iliqn * _l, iliqn * _r)
    {
        st=_st;
        lazy.first=l1;
        lazy.second=l2;
        l=_l;
        r=_r;
    }
};
typedef iliqn * piliqn;
long long n,q;
piliqn tree[100005];
void push_lazy(piliqn & tree, long long l, long long r)
{
    if(tree == NULL)
    {
        return;
    }
    long long mid=(l+r)/2;
    tree->st += (r-l+1) * tree->lazy.first + (r-l+1)*(r-l)*tree->lazy.second/2;
    //cout<<l<<" "<<r<<" "<<tree->st<<endl;
    if(l == r || (tree->lazy.first ==0 && tree->lazy.second==0))
    {
        tree->lazy.first = tree->lazy.second=0;
        return;
    }
    if(tree->l == NULL)
    {
        tree->l = new iliqn();
    }
    if(tree->r == NULL)
    {
        tree->r = new iliqn();
    }
    //cout<<l<<" "<<mid<<" "<<tree->lazy.first<<endl;
    tree->l->lazy.first += tree->lazy.first;
    tree->l->lazy.second +=tree->lazy.second;
    tree->r->lazy.first += tree->lazy.first + (mid-l+1) * tree->lazy.second;
    tree->r->lazy.second += tree->lazy.second;
    tree->lazy.first = tree->lazy.second = 0;
}
void update(piliqn & tree, long long l, long long r, long long u, long long v, long long st, long long d)
{
    push_lazy(tree,l,r);
    if(l>r||l>v||r<u)
        return;
    if(l>=u&&r<=v)
    {
        //tree->st = (r-l+1)*st + (r-l+1)*(r-l)*d/2;
        tree->lazy.first+=st;
        tree->lazy.second+=d;
        push_lazy(tree,l,r);
        return;
    }
    long long mid=(l+r)/2;
    if(tree->l == NULL)
    {
        tree->l = new iliqn();
    }
    if(tree->r == NULL)
    {
        tree->r = new iliqn();
    }
    update(tree->l, l, mid, u, v, st, d);
    update(tree->r, mid+1, r, u, v, st+(mid-u+1)*d, d);
    tree->st = tree->l->st + tree->r->st;
    //cout<<l<<" "<<r<<" "<<tree->l->st<<" "<<tree->r->st<<endl;
}
long long sum(piliqn & tree, long long l, long long r, long long u, long long v)
{
    push_lazy(tree, l, r);
    if(l>r||l>v||r<u||tree==NULL)
    {
        return 0;
    }
    //cout<<l<<" "<<r<<" "<<tree->st<<endl;
    if(l>=u&&r<=v)
    {
        return tree->st;
    }
    long long mid=(l+r)/2;
    return sum(tree->l, l, mid, u, v) + sum(tree->r, mid+1, r, u, v);
}
long long rows=1e5;
void query1()
{
    long long row, from, to, st, d;
    cin>>row>>from>>to>>st>>d;
    update(tree[row],1,n,from,to,st,d);
}
long long query2()
{
    long long row,from,to;
    cin>>row>>from>>to;
    return sum(tree[row],1,n,from,to);
}
void query3()
{
    long long pow1,pow2;
    cin>>pow1>>pow2;
    tree[pow2]= new iliqn(tree[pow1]->st, tree[pow1]->lazy.first, tree[pow1]->lazy.second, tree[pow1]->l, tree[pow1]->r);
}
int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin>>n>>q;
    long long t;
    long long i;
    for(i=1;i<=rows;i++)
    {
        tree[i]=new iliqn();
    }
    for(i=0;i<q;i++)
    {
        cin>>t;
        if(t==1)
        {
            query1();
        }
        if(t==2)
        {
            cout<<query2()<<endl;
        }
        if(t==3)
        {
            query3();
        }
        //cout<<sum(tree[1],1,n,5,5)<<" "<<sum(tree[2],1,n,5,5)<<" "<<sum(tree[2],1,n,6,6)<<endl;
    }
    return 0;
}
/*
10 15
1 1 1 5 1 2
2 1 1 1
2 1 5 5
2 1 1 10
2 2 1 10
3 1 2
2 2 1 10
1 2 6 10 1 2
2 2 1 10
2 1 1 10
2 2 5 6
1 1 1 10 -1 -2
2 2 1 10
2 1 1 5
2 1 6 10
*/
