#include <bits/stdc++.h>
#include "bookshelf.h"

#define BookShelf bookshelf
#define BookSwap bookswap
#define Answer answer

using namespace std;

const int32_t MAX_N = 1e5 + 5;

int32_t N, ans[MAX_N];
vector< int32_t > shelf, inds;

/**
int64_t BookSwap(int32_t ind1, int32_t ind2) {
	swap(shelf[ind1], shelf[ind2]);

	int64_t cnt = 0;
	for(int32_t i = 1; i <= N; i++) {
		for(int32_t j = i - 1; j >= 1; j--) {
			if(shelf[i] < shelf[j]) {
				cnt++;
			}
		}
	}

	return cnt;
}

void Answer(int32_t p[]) {
	for(int32_t i = 1; i <= N; i++) {
		cout << p[i] << " ";
	}
	cout << endl;
}
*/

void BookShelf(int32_t n, int64_t invCnt) {
	N = n;

	inds.resize(n + 1);
	for(int32_t i = 1; i <= n; i++) {
		inds[i] = i;
	}
	
	//push 1 to front
	for(int32_t i = n - 1; i >= 1; i--) {
		int64_t newCnt = BookSwap(i, i + 1);
		swap(inds[i], inds[i + 1]);

		if(newCnt > invCnt) {
			BookSwap(i, i + 1);
			swap(inds[i], inds[i + 1]);
		}
		else {
			invCnt = newCnt;
		}
	}

	// push n to back
	for(int32_t i = 1; i <= n - 1; i++) {
		int64_t newCnt = BookSwap(i, i + 1);
		swap(inds[i], inds[i + 1]);

		if(newCnt > invCnt) {
			BookSwap(i, i + 1);
			swap(inds[i], inds[i + 1]);
		}
		else {
			invCnt = newCnt;
		}
	}

	ans[inds[1]] = 1;
	ans[inds[n]] = n;
	for(int32_t i = 2; i <= n - 1; i++) {
		int64_t aux1 = (BookSwap(1, i) - invCnt + 1) / 2;
		BookSwap(1, i);
		int64_t aux2 = (BookSwap(i, n) - invCnt - 1) / 2;
		BookSwap(i, n);
		
		ans[inds[i]] = aux1 + aux2 + 1;
	}

	Answer(ans);
}

/**
int main() {
	shelf = { 0, 4, 3, 1, 5, 2 };

	BookShelf(5, 6);	
}
*/
