#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#define pb push_back
#define mp make_pair
using namespace std;
const int N = 1e5 + 5;
const int PERS = 33;

int n, q;

int root[N];
int val[N * PERS], lazy_st[N * PERS], lazy_d[N * PERS];
int L[N * PERS], R[N * PERS], NFI = 1;

void build(int id, int low, int high)
{
    if(low == high)
    {
        val[id] = 0;
        return;
    }

    L[id] = NFI++;
    R[id] = NFI++;

    int mid = (low + high) / 2;

    build(L[id], low, mid);
    build(R[id], mid + 1, high);
}

void refresh(int id, int low, int high)
{
    long long sz = high - low + 1;
    long long mid = (low + high) / 2;

    val[id] += sz * lazy_st[id];
    val[id] += (((sz - 1) * sz) / 2) * lazy_d[id];

    if(L[id])
    {
        lazy_st[L[id]] += lazy_st[id];
        lazy_d[L[id]] += lazy_d[id];
    }
    if(R[id])
    {
        sz = (mid + 1 - low + 1);

        lazy_st[R[id]] += lazy_st[id] + (sz - 1) * lazy_d[id];
        lazy_d[R[id]] += lazy_d[id];
    }

    lazy_st[id] = lazy_d[id] = 0;
}

int update(int id, int low, int high, int l, int r, int st,int d)
{
    int ID = NFI++;

    if(l <= low && r >= high)
    {
        lazy_st[ID] += st + (low - l) * d;
        lazy_d[ID] += d;

        refresh(ID, low, high);
        return ID;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int i;

    cin >> n >> q;

    build(0, 1, n);



    return 0;
}
