#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#define pb push_back
#define mp make_pair
using namespace std;
const int N = 1e5 + 5;
const int SQRTN = 318;
const int PERS = 100;

int n, Q;

struct query{

  int row, from, to;
  long long st, d;

}q[N];

long long val[N * PERS], lazy_st[N * PERS], lazy_d[N * PERS];
int L[N * PERS], R[N * PERS], NFI = 2;

void build(int id, int low, int high)
{
    if(low == high)
    {
        val[id] = 0;
        return;
    }

    L[id] = NFI++;
    R[id] = NFI++;

    int mid = (low + high) / 2;

    build(L[id], low, mid);
    build(R[id], mid + 1, high);
}

void refresh(int id, int low, int high)
{
    long long sz = high - low + 1;
    long long mid = (low + high) / 2;

    val[id] += sz * lazy_st[id];
    val[id] += (((sz - 1) * sz) / 2) * lazy_d[id];

    if(L[id])
    {
        lazy_st[L[id]] += lazy_st[id];
        lazy_d[L[id]] += lazy_d[id];
    }
    if(R[id])
    {
        sz = (mid + 1 - low + 1);

        lazy_st[R[id]] += lazy_st[id] + (sz - 1) * lazy_d[id];
        lazy_d[R[id]] += lazy_d[id];
    }

    lazy_st[id] = lazy_d[id] = 0;
}

void update(int id, int low, int high, int l, int r, long long st, long long d)
{
    refresh(id, low, high);

    if(l > high || r < low)
        return;
    if(l <= low && r >= high)
    {
        lazy_st[id] += st + 1LL * (low - l) * d;
        lazy_d[id] += d;

        refresh(id, low, high);

        return;
    }

    int mid = (low + high) / 2;

    update(L[id], low, mid, l, r, st, d);
    update(R[id], mid + 1, high, l, r, st, d);

    val[id] = val[L[id]] + val[R[id]];
}

long long query(int id, int low, int high, int l, int r)
{
    refresh(id, low, high);

    if(l > high || r < low)
        return 0LL;
    if(l <= low && r >= high)
        return val[id];

    int mid = (low + high) / 2;

    return query(L[id], low, mid, l, r) + query(R[id], mid + 1, high, l, r);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int i;
    int type, row, from, to;
    long long st, d;

    cin >> n >> Q;

    build(1, 1, n);
    for(i = 1; i <= Q; i++)
    {
        cin >> type;

        if(type == 1)
        {
            cin >> row >> from >> to >> st >> d;
            update(1, 1, n, from, to, st, d);
        }
        if(type == 2)
        {
            cin >> row >> from >> to;
            cout << query(1, 1, n, from, to) << endl;
        }

        if(type == 3)
        {
            //
        }
    }


    return 0;
}


/*

10 15
1 1 1 5 1 2
2 1 1 1
2 1 5 5
2 1 1 10

*/
