#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#define pb push_back
#define mp make_pair
using namespace std;
const int N = 1e5 + 5;
int SQRTN = 313;
const int PERS = 2;

int n, Q;

struct query{

  int type, row, from, to;
  long long st, d;

}q[N];

struct segment_tree{

    long long val[N * PERS], lazy_st[N * PERS], lazy_d[N * PERS];

    void build(int id, int low, int high)
    {
        if(low == high)
        {
            val[id] = 0;
            return;
        }

        int mid = (low + high) / 2;

        build(id * 2, low, mid);
        build(id * 2 + 1, mid + 1, high);
    }

    void refresh(int id, int low, int high)
    {
        long long sz = high - low + 1;
        long long mid = (low + high) / 2;

        val[id] += sz * lazy_st[id];
        val[id] += (((sz - 1) * sz) / 2) * lazy_d[id];

        if(low < high)
        {
            lazy_st[id * 2] += lazy_st[id];
            lazy_d[id * 2] += lazy_d[id];

            sz = (mid + 1 - low + 1);

            lazy_st[id * 2 + 1] += lazy_st[id] + (sz - 1) * lazy_d[id];
            lazy_d[id * 2 + 1] += lazy_d[id];
        }

        lazy_st[id] = lazy_d[id] = 0;
    }

    void update(int id, int low, int high, int l, int r, long long st, long long d)
    {
        refresh(id, low, high);

        if(l > high || r < low)
            return;
        if(l <= low && r >= high)
        {
            lazy_st[id] += st + 1LL * (low - l) * d;
            lazy_d[id] += d;

            refresh(id, low, high);

            return;
        }

        int mid = (low + high) / 2;

        update(id * 2, low, mid, l, r, st, d);
        update(id * 2 + 1, mid + 1, high, l, r, st, d);

        val[id] = val[id * 2] + val[id * 2 + 1];
    }

    long long query(int id, int low, int high, int l, int r)
    {
        refresh(id, low, high);

        if(l > high || r < low)
            return 0LL;
        if(l <= low && r >= high)
            return val[id];

        int mid = (low + high) / 2;

        return query(id * 2, low, mid, l, r) + query(id * 2 + 1, mid + 1, high, l, r);
    }
}seg[301];

int seen_row[N], rep[N], heavies;
vector <query> updates[N];

long long light_result(int row, int l, int r)
{
    int i;
    long long b, e;
    long long x;

    long long res = 0, cur;

    for(i = 0; i < updates[row].size(); i++)
    {
        if(r < updates[row][i].from || l > updates[row][i].to)
            continue;

        b = max(l, updates[row][i].from);
        e = min(r, updates[row][i].to);

        cur  = (e - b + 1) * updates[row][i].st;

        x = (e - updates[row][i].from) * (e - updates[row][i].from + 1) / 2;
        cur += x * updates[row][i].d;

        if(b > updates[row][i].from)
        {
         x = (b - updates[row][i].from - 1) * (b - updates[row][i].from ) / 2;
         cur -= x * updates[row][i].d;
        }

        res += cur;
    }

    return res;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int i;

    cin >> n >> Q;

    SQRTN = 300;
    for(i = 1; i <= Q; i++)
    {
        cin >> q[i].type;

        if(q[i].type == 1)
        {
            cin >> q[i].row >> q[i].from >> q[i].to >> q[i].st >> q[i].d;
        }
        if(q[i].type == 2)
        {
            cin >> q[i].row >> q[i].from >> q[i].to;
        }

        if(q[i].type == 3)
        {
            cin >> q[i].from >> q[i].to;
        }
    }

    for(i = 1; i <= Q; i++)
    {
        if(q[i].type == 1)
            seen_row[q[i].row]++;
    }


    for(i = 1; i <= Q; i++)
    {
        if(seen_row[q[i].row] >= SQRTN && rep[q[i].row] == 0)
        {
            rep[q[i].row] = heavies++;
            seg[rep[q[i].row]].build(1, 1, n);
        }
    }

    for(i = 1; i <= Q; i++)
    {
        if(seen_row[q[i].row] >= SQRTN)
        {
            if(q[i].type == 1)
                seg[rep[q[i].row]].update(1, 1, n, q[i].from, q[i].to, q[i].st, q[i].d);

            if(q[i].type == 2)
                cout << seg[rep[q[i].row]].query(1, 1, n, q[i].from, q[i].to) << endl;
        }
        else
        {
            if(q[i].type == 2)
                cout << light_result(q[i].row, q[i].from, q[i].to) << endl;
            else
                updates[q[i].row].pb(q[i]);
        }
    }


    return 0;
}

/*

10 5
1 1 1 5 1 2
2 1 1 1
2 1 5 5
2 1 1 10
2 2 1 10

*/
