#include <iostream>
#include <cstdio>
using namespace std;

typedef long long Int;

const int N=(1e5)+5;

struct Element
{
 Int sum;
 Int lazy;
 Int aplazy;
 Int left;
 Int right;
};

Element tree[4*N];

void Refresh(int node,int low,int high)
{
 Int total,mid;

 mid=(low+high)/2;

  if(low==high)
  {
   tree[node].sum+=(high-low+1)*tree[node].lazy;
   tree[node].lazy=0;

   total=((tree[node].left+tree[node].right)*(tree[node].right-tree[node].left+1))/2;
   tree[node].sum+=total*tree[node].aplazy;
   tree[node].aplazy=0;
   return;
  }

 tree[node].sum+=(high-low+1)*tree[node].lazy;
 tree[node*2].lazy+=tree[node].lazy;
 tree[node*2+1].lazy+=tree[node].lazy;
 tree[node].lazy=0;

 total=((tree[node].left+tree[node].right)*(tree[node].right-tree[node].left+1))/2;
 tree[node].sum+=total*tree[node].aplazy;
 tree[node*2].aplazy+=tree[node].aplazy;
 tree[node*2+1].aplazy+=tree[node].aplazy;

 tree[node*2].left=tree[node].left;
 tree[node*2].right=tree[node].left+(mid-low);

 tree[node*2+1].left=tree[node].right-(high-mid-1);
 tree[node*2+1].right=tree[node].right;

 tree[node].aplazy=0;
}

void Update(int node,int low,int high,int l,int r,Int st,Int d)
{
 int mid;

 Refresh(node,low,high);

  if(high<l || low>r)
   return;

  if(low>=l && high<=r)
  {
   tree[node].lazy=st;
   tree[node].aplazy=d;
   tree[node].left=low-l;
   tree[node].right=high-l;
   Refresh(node,low,high);
   return;
  }

 mid=(low+high)/2;
 Update(node*2,low,mid,l,r,st,d);
 Update(node*2+1,mid+1,high,l,r,st,d);

 tree[node].sum=tree[node*2].sum+tree[node*2+1].sum;

  if(low>=l)
   tree[node].left=low-l;
  else
   tree[node].left=0;

  if(high<=r)
   tree[node].right=high-l;
  else
   tree[node].right=r-l;
}

Int Query(int node,int low,int high,int l,int r)
{
 int mid;

 Refresh(node,low,high);

  if(high<l || low>r)
   return 0;

  if(low>=l && high<=r)
   return tree[node].sum;

 mid=(low+high)/2;
 return Query(node*2,low,mid,l,r)+Query(node*2+1,mid+1,high,l,r);
}

int main()
{

int n,q,i,from,to,type,row;
Int st,d,ans;

scanf("%d%d",&n,&q);

 for(i=1;i<=q;i++)
 {
  scanf("%d",&type);

   if(type==1)
   {
    scanf("%d%d%d%lld%lld",&row,&from,&to,&st,&d);
    Update(1,1,n,from,to,st,d);
   }
   else
   {
    scanf("%d%d%d",&row,&from,&to);
    ans=Query(1,1,n,from,to);
    printf("%lld\n",ans);
   }
 }

return 0;
}
